=== debian/changelog ===
kdevelop (4:5.2.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.2.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 21 Aug 2018 22:29:33 +0200

kdevelop (4:5.2.3-2) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Team upload.
  * Add missing qml modules dependencies (Closes: #901618).
    Thanks Michael Bosse for the bug report!

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 19 Jun 2018 10:31:31 -0300

kdevelop (4:5.2.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add the libkf5purpose-dev build dependency, to enable patch sharing.
  * Add the libkf5itemmodels-dev dependency in kdevelop-dev, as the cmake
    config file says.
  * Update Vcs-* fields.
  * Remove empty line at the end of changelog.

 -- Pino Toscano <pino@debian.org>  Tue, 22 May 2018 07:42:30 +0200

kdevelop (4:5.2.1-2) unstable; urgency=medium

  * Team upload.
  * Build without Clang also on ia64, and riscv64.
  * Bump Standards-Version to 4.1.4, no changes required.
  * Switch Vcs-* fields to salsa.debian.org.
  * Fix typo in description of patch optional-clang.diff.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Pass --list-missing to dh_missing, instead of dh_install.

 -- Pino Toscano <pino@debian.org>  Tue, 08 May 2018 06:40:00 +0200
